version: '3.9'

services:
  mongo:
    image: mongo:6.0
    ports:
      - "27017:27017"
    command: ["--auth"]
    environment:
      - MONGO_INITDB_ROOT_USERNAME=admin
      - MONGO_INITDB_ROOT_PASSWORD=admin
      - MONGO_INITDB_DATABASE=mediator
    volumes:
      - ./initdb.js:/docker-entrypoint-initdb.d/initdb.js
    logging:
      driver: "json-file"
      options:
        max-size: "10m" # limit each log file to 10mb
        max-file: "3" # keep a maximum of 3 log files

  identus-mediator:
    image: ghcr.io/hyperledger/identus-mediator:${MEDIATOR_VERSION:-latest}

    logging:
      driver: "json-file"
      options:
        max-size: "10m" # limit each log file to 10mb
        max-file: "3" # keep a maximum of 3 log files
    ports:
      - "8080:8080"
    environment:
      # Creates the identity:
      # These keys are for demo purpose only for production deployments generate keys
      # Please follow the README file for guidelines on How to generate JWK format keys
      # KEY_AGREEMENT KEY_AUTHENTICATION are using format JOSE(JWK) OKP type base64urlsafe encoded keys
      - KEY_AGREEMENT_D=Z6D8LduZgZ6LnrOHPrMTS6uU2u5Btsrk1SGs4fn8M7c
      - KEY_AGREEMENT_X=Sr4SkIskjN_VdKTn0zkjYbhGTWArdUNE4j_DmUpnQGw
      - KEY_AUTHENTICATION_D=INXCnxFEl0atLIIQYruHzGd5sUivMRyQOzu87qVerug
      - KEY_AUTHENTICATION_X=MBjnXZxkMcoQVVL21hahWAw43RuAG-i64ipbeKKqwoA
      # - SERVICE_ENDPOINTS=http://localhost:8080;ws://localhost:8080/ws
      - SERVICE_ENDPOINTS=$SERVICE_ENDPOINTS
      # NOTE: we set this in set-env.sh
      - MONGODB_USER=admin
      - MONGODB_PASSWORD=admin
      - MONGODB_PROTOCOL=mongodb
      - MONGODB_HOST=mongo
      - MONGODB_PORT=27017
      - MONGODB_DB_NAME=mediator
    depends_on:
      - "mongo"
    extra_hosts:
      - "host.docker.internal:host-gateway"
